.cseg
; ***********************************************************************************************
;	Daten im Programmsegment			(c) 2024 by DC7GB unter: BY-NC-SA 4.0
; ***********************************************************************************************

;	Dmpfungsparameter fr Si571: MAXVCO in kHz, (H:L) = LP1,LP2

LPTABELLE:	.dd	2087014		; 1
		.db	$2,$2
		.dd	2170016		; 2
		.db	$2,$3
		.dd	2332545		; 3
		.db	$3,$3
		.dd	2425468		; 4
		.db	$3,$4
		.dd	2500000		; 5
		.db	$4,$4


.eseg
; ***********************************************************************************************
; Datenbereich (EEPROM):				(c) 2024 by DC7GB unter: BY-NC-SA 4.0
; ***********************************************************************************************


.org	0
EEPARKPOS:	.db	0		; Parkposition fr EE-Pointer (nicht verwenden!)

; -------------------------------------
EESTART:				; Anfang des auszulesenden Bereichs

EEASCADR:	.db	"999",0		; Frequenz in kHz als ASCII-Code (max 6 Byte!!!)
.org	8
; nchstes EEPROM-Byte folgt erst hier:



.dseg
; ***********************************************************************************************
;	Daten im RAM					(c) 2024 by DC7GB unter: BY-NC-SA 4.0
; ***********************************************************************************************

; -------------------------------------
; Oszillator:

STORESTART:	; Anfang des ausgelesen EE-Bereichs
ascadr:		.byte	6		; Frequenz aus EEPROM: "######" in kHz
STOREEND:	; Ende des ausgelesenen EE-Bereichs

binqrg:		.byte	4		; (L..H) Oszillatorfrequenz binr
lsdiv:		.byte	1		; berechneter Teiler LS_DIV
lsdivcode:	.byte	1		; ermittelter LSDIV-Code fr Si514
hsdiv:		.byte	2		; berechneter Teiler HS_DIV
mint:		.byte	1		; berechneter ganzzahliger Anteil von M
m:		.byte	5		; berechnetes M 
fvco:		.byte	4		; berechnete VCO-Frequenz
lp1:		.byte	1		; DSP Loop-Konstante1
lp2:		.byte	1		; DSP Loop-Konstante2

; -------------------------------------
; I2C-Daten:

i2canzahl:	.byte	1		; Anzahl der noch ausstehenden READ- oder WRITE-Operationen
;
i2cdaten:
regadr:		.byte	1		; Registeradresse
reg0:					; LP1, LP2
reg128:					; oder:	RST	
reg132:					; oder:	OE, FCAL
reg5:		.byte	1		; oder:	LMFRAC
reg6:		.byte	1		; MFRAC
reg7:		.byte	1		; MFRAC
reg8:		.byte	1		; MINT, MFRAC
reg9:		.byte	1		; MINT
reg10:		.byte	1		; HSDIV
reg11:		.byte	1		; LSDIV, HSDIV
i2cstatus:	.byte	1		; I2C-Statusbyte
i2cerror:	.byte	1		; I2C-Fehlernummer

; -------------------------------------
; Rechenregister:

buf64:		.byte	8		; (LS..MS) 64Bit Rechenbuffer fr MUL32Z32 und DIV64Z32
		.byte	8		; (LS..MS) 64Bit Mul-Register fr MUL32Z32 und 32Bit Rest fr DIV64Z32


; -------------------------------------
; Timer:

t10ms:		.byte	1		; durchlaufender 10ms-Timer

; -------------------------------------
; Ergnzung:

DUMMY:		.byte	1


