.cseg
; ***********************************************************************************************
;	Initialisierung:			(c) 2024 by DC7GB unter: BY-NC-SA 4.0
; ***********************************************************************************************


INIT:		clr	temp			; lsche PUD
		out	MCUCR,temp		; PullUp ist frei gegeben

; ----------------------------------------------
; Ports initialisieren:

		ldi	temp,DRB		;; PortB einstellen
		out	DDRB,temp
		ldi	temp,PULUPB		;; Pull-up an B-Eingngen aktivieren
		out	PORTB,temp

; ----------------------------------------------
; Timer0 fr 10ms Systemtakt:
	
		ldi	temp,0b10		;; CTC
		out	TCCR0A,temp		;; ...setzen
		ldi	temp,0b101		;; Prescaler :1024
		out	TCCR0B,temp		;; ...setzen
		ldi	temp,TICS0		;; Timerkonstante
		out	OCR0A,temp		;; ...setzen
		ldi	temp,0b10000		;; Timer0 Compare Match A
		out	TIMSK,temp		;; ...frei geben

; ----------------------------------------------
; RAM und Register initialisieren:

		clr	flags0
;
		sbi	PORTB,SDA		;; Ruhezustand setzen
		sbi	PORTB,SCL		;; Ruhezustand setzen
		ldi	temp,10			;; Starte 100ms-
		sts	t10ms,temp		;; ...Timer
		ldi	temp,2			;; DSP
		sts	lp1,temp		;; ...EInstellungen
		sts	lp2,temp		;; ...fest vorgeben

; ---------------------------------------------
; EEPROM auslesen:

		ldiw	Z,EESTART		;; Quelle des auszulesenen EE-Bereichs
		ldiw	Y,STORESTART		;; Ziel der Daten im RAM
EELOAD:		rcall	eeread			;; lese ein Byte ein
		adiw	Z,1			;; ...und erhhe EEPROM-Adresse
		st	Y+,temp			;; speichere einegelesene Daten im RAM
		cpiw	Y,STOREEND		;; Ende gefunden?
		brne	eeload			;; nein...

; ----------------------------------------------
; SI514 mit EEPROM-QRG programmieren:

		rcall	resetsi514		;; initialisiere Si514 nach Power-On
		rcall	ascqrg2bin		;; Konvertiere die ASCII-Frequenz nach 32Bit Binr
		rcall	si514qrg		;; SI514-Parameter aus ASCII-Frequenz berechnen
		rcall	send2si514		;; Sende Parameter zum Si514

; ----------------------------------------------
; Sleep-Mode auf Idle setzen

		ldi	temp,(1<<SE)		;; SE=1: Freigabe / SM2..0=000: IDLE
		out	MCUCR,temp

; ----------------------------------------------

		rcall	wait200ms		;; warte auf Systemberuhigung

; -------------
		ret

