.cseg
; ***********************************************************************************************
;	sonstige Unbterprogramme		(c) 2024 by DC7GB unter: BY-NC-SA 4.0
; ***********************************************************************************************


; -----------------------------------------------------------------------------------------------
; 64Bit Multiplikation 64(Z) = 64(Z) x 8(temp)				(ca. 389s @ 8MHz)
; -----------------------------------------------------------------------------------------------

MUL64Z8:	mov	akku0,temp
		clr	akku1
MUL64Z16:	clr	akku2
		clr	akku3

; -----------------------------------------------------------------------------------------------
; 64Bit Multiplikation 64(Z) = 64(Z) x 32(akku3..0)			(ca. 389s @ 8MHz)
; -----------------------------------------------------------------------------------------------

MUL64Z32:	push	counter
		push	buffer
		push	YL
		push	YH
; -------------
		movw	Y,Z			; rette Bufferadresse
		ldi	counter,8
		clr	temp
MUL64ZMOVE:	ld	buffer,Z		; lade Multiplikand
		std	Z+8,buffer		; ...ins Multiplikanden-Register
		st	Z+,temp			; ...und lsche Ergebnisbyte
		dec	counter			; alle Bytes bearbeitet?
		brne	mul64zmove		; nein...
		movw	Z,Y			; lade Bufferadresse zurck
; -------------
		ldi	counter,32		; 32 Bit Multiplikation
MUL64Z32A:	push	counter			; rette Bitzhler
		ldi	counter,8		; 64Bits verschieben
		clc
MUL64ZLOOP1:	ld	temp,Z			; schiebe
		rol	temp			; ...das 64Bit
		st	Z+,temp			; ...Ergebnis
		dec	counter			; ...nach links, fertig?
		brne	mul64zloop1		; nein...
		movw	Z,Y			; lade Bufferadresse zurck
; 32Bit MUL:
		lsl	akku0			; schiebe MS-Bit des
		rol	akku1			; ...Multiplikators
		rol	akku2			; ...ins
		rol	akku3			; ...Carry, CY=1?
		brcc	mul64z32b		; nein...
; 64Bit ADD:
		ldi	counter,8		; 8Bytes = 64 Bit addieren
		clc
MUL64ZLOOP2:	ld	temp,Z			; addiere
		ldd	buffer,Z+8		; ...ein
		adc	temp,buffer		; ...Byte des
		st	Z+,temp			; ...Multiplikanden 
		dec	counter			; alle Bytes bearbeitet?
		brne	mul64zloop2		; nein...
		movw	Z,Y			; lade Bufferadresse zurck
;
MUL64Z32B:	pop	counter			; lade Bitzhler zurck
		dec	counter			; alle 32 Bit bearbeitet?
		brne	mul64z32a		; nein...
; -------------
MUL64Z32END:	pop	YH
		pop	YL
		pop	buffer
		pop	counter
		ret



; -----------------------------------------------------------------------------------------------
; 32Bit Division 32(Z) = 32(Z) / (akku1..0), Rest 32(Z+8)		(ca. 234s @ 8MHz)
; -----------------------------------------------------------------------------------------------

DIV32Z16:	push	counter
; -------------
		clr	temp			; Divisionsrest
		std	Z+8,temp		; ...zu
		std	Z+9,temp		; ...Begin
		std	Z+10,temp		; ...komplett
		std	Z+11,temp		; ...lschen
;
		ldi	counter,32		; 32 bit Division
DIV32_16A:	ld	temp,Z			; LS-Byte des Dividenten
		lsl	temp			; ...ins MSB schieben
		st	Z,temp
		ldd	temp,Z+1
		rol	temp
		std	Z+1,temp
		ldd	temp,Z+2
		rol	temp
		std	Z+2,temp
		ldd	temp,Z+3
		rol	temp
		std	Z+3,temp
;
		ldd	temp,Z+8		; MS-Bit in CY
		rol	temp			; ...den Rest
		std	Z+8,temp		; ...schieben
		ldd	temp,Z+9
		rol	temp
		std	Z+9,temp
		ldd	temp,Z+10
		rol	temp
		std	Z+10,temp
		ldd	temp,Z+11
		rol	temp
		std	Z+11,temp
;
		ldd	temp,Z+8		; Divisor
		cp	temp,akku0		; ...enthalten?
		ldd	temp,Z+9
		cpc	temp,akku1
		brcs	div32_16b		; nein...
;
		ldd	temp,Z+8		; Divisor
		sub	temp,akku0		; ...abziehen
		std	Z+8,temp
		ldd	temp,Z+9
		sbc	temp,akku1
		std	Z+9,temp
;
		ld	temp,Z			; Ergebnisbit
		inc	temp			; ...setzen
		st	Z,temp
DIV32_16B:	dec	counter			; alle 32 Bit bearbeitet?
		brne	div32_16a		; nein...
; -------------
		pop	counter
		ret



; -----------------------------------------------------------------------------------------------
; 64Bit Division 64(Z) = 64(Z) / 32(akku3..0), Rest 32(Z+8..11)		(ca. 652s @ 8MHz)
; -----------------------------------------------------------------------------------------------

DIV64Z32:	push	counter
		push	temp
; -------------
		clr	temp			; Divisionsrest
		std	Z+8,temp		; ...zu
		std	Z+9,temp		; ...Begin
		std	Z+10,temp		; ...komplett
		std	Z+11,temp		; ...lschen
;
		ldi	counter,64		; 64 bit Division
DIV64A:		ld	temp,Z			; LS-Byte des Multiplikators
		lsl	temp			; ...am Anfang der Routine
		st	Z,temp
		ldd	temp,Z+1
		rol	temp
		std	Z+1,temp
		ldd	temp,Z+2
		rol	temp
		std	Z+2,temp
		ldd	temp,Z+3
		rol	temp
		std	Z+3,temp
		ldd	temp,Z+4
		rol	temp
		std	Z+4,temp
		ldd	temp,Z+5
		rol	temp
		std	Z+5,temp
		ldd	temp,Z+6
		rol	temp
		std	Z+6,temp
		ldd	temp,Z+7
		rol	temp
		std	Z+7,temp
; Rest:
		ldd	temp,Z+8		; MS-Bit in
		rol	temp			; ...den Rest
		std	Z+8,temp		; ...schieben
		ldd	temp,Z+9
		rol	temp
		std	Z+9,temp
		ldd	temp,Z+10
		rol	temp
		std	Z+10,temp
		ldd	temp,Z+11
		rol	temp
		std	Z+11,temp
; Test:
		ldd	temp,Z+8		; Divisor
		cp	temp,akku0		; ...enthalten?
		ldd	temp,Z+9
		cpc	temp,akku1
		ldd	temp,Z+10
		cpc	temp,akku2
		ldd	temp,Z+11
		cpc	temp,akku3
		brcs	div64b			; nein...
; Sub:
		ldd	temp,Z+8		; Divisor
		sub	temp,akku0		; ...abziehen
		std	Z+8,temp
		ldd	temp,Z+9
		sbc	temp,akku1
		std	Z+9,temp
		ldd	temp,Z+10
		sbc	temp,akku2
		std	Z+10,temp
		ldd	temp,Z+11
		sbc	temp,akku3
		std	Z+11,temp
; Set:
		ld	temp,Z			; Ergebnisbit
		inc	temp			; ...setzen
		st	Z,temp
DIV64B:		dec	counter			; alle 64 Bit bearbeitet?
		brne	div64a			; nein...
; -------------
		pop	temp
		pop	counter
		ret



; -----------------------------------------------------------------------------------------------
; teste Bit0(Z), ob eine Rundung ntig ist, teile durch 2 addiere ggf 1:
; -----------------------------------------------------------------------------------------------

ROUND64Z:	push	YH
		push	YL
		push	counter
; -------------
		ld	const,Z			; lade LS-Byte des Zwischenergebnisses
		movw	Y,Z			; lade Zeiger auf Rechenregister
		adiw	Y,8			; zeige auf MS-Byte des Zwischenergebnisses
		ldi	counter,8		; bearbeite 8 Bytes = 64Bit
; teile durch 2
		clc				; ergnze 0-Bit fr MS-Bit
RND64Z_LOOP1:	ld	temp,-Y			; schiebe Byte
		ror	temp			; ...um ein Bit nach rechts
		st	Y,temp			; ...entspricht Teilung durch 2
		dec	counter			; fertig?
		brne	rnd64z_loop1		; nein...
; Runden?
		sbrs	const,BIT0		; Rundung ntig?
		rjmp	rnd64Z_end		; nein...
; addiere 1
		movw	Y,Z			; lade Zeiger auf Rechenregister
		ldi	buffer,1		; Rundungskonstante
		clr	const			; ...mit 64Bit-Erweiterung
		ld	temp,Y			; addiere 
		add	temp,buffer		; ...Konstante
		st	Y+,temp			; ...und runde LS-Byte
		ldi	temp,7			; noch 7 Bytes = 56Bit
RND64Z_LOOP2:	ld	temp,Y			; addiere 
		adc	temp,const		; ...0-Erweiterung mit CY
		st	Y+,temp			; ...und runde LS-Byte
		dec	counter			; fertig?
		brne	rnd64z_loop2		; nein...
;
RND64Z_END:	pop	counter
		pop	YL
		pop	YH
		ret
		


; -----------------------------------------------------------------------------------------------
; Lsche den 64Bit Rechenbuffer:					(ca. 13,3s @ 8MHz)
; -----------------------------------------------------------------------------------------------

CLRBUF64:	push	ZH
		push	ZL
		push	temp
		push	counter
; -------------
		ldiw	Z,buf64			; Adresse des Rechenbuffers
		ldi	counter,16		; 2x 8Byte = 64Bit
		clr	temp			; lsche
CLRBUF64_LOOP:	st	Z+,temp			; ...Buffer
		dec	counter			; fertig?
		brne	clrbuf64_loop		; nein...
; -------------
		pop	counter
		pop	temp
		pop	ZL
		pop	ZH
		ret



; -----------------------------------------------------------------------------------------------
; Fehlernummer in (temp) als Impulszahl an TEST ausgeben:
; -----------------------------------------------------------------------------------------------

ERROR:		push	temp
; -------------
ERROR_LOOP:	dec	temp			; fertig?
		brmi	errwait			; ja...
		sbi	PORTB,TEST		; H ausgeben
		rcall	wait10ms		; etwas warten
		cbi	PORTB,TEST		; L ausgeben
		rcall	wait10ms		; etwas warten
		rjmp	error_loop
;
ERRWAIT:	rcall	wait200ms		; Abstand halten
; -------------
		pop	temp
		ret



; -----------------------------------------------------------------------------------------------
; Exklusiv 200ms bei 8MHz warten:
; -----------------------------------------------------------------------------------------------

WAIT200MS:	push	temp
; -------------
		ldi	temp,20
W200MS_LOOP:	rcall	wait10ms
		dec	temp
		brne	w200ms_loop
; -------------
		pop	temp
		ret



; -----------------------------------------------------------------------------------------------
; Exklusiv 20ms/10ms bei 8MHz warten:
; -----------------------------------------------------------------------------------------------

WAIT20MS:	rcall	wait10ms		; warte 20ms
;
WAIT10MS:	push	akku0			; warte 10ms
		push	temp
; -------------
		ldi	temp,100
		mov	akku0,temp
W100US_LOOP:	rcall	wait100us		; warte 100s
		dec	akku0
		brne	w100us_loop
; -------------
		pop	temp
		pop	akku0
		ret



; -----------------------------------------------------------------------------------------------
; Exklusiv 100s bei 8MHz warten:
; -----------------------------------------------------------------------------------------------

WAIT100US:	push	akku0
		push	temp
; -------------
		ldi	temp,196
		mov	akku0,temp
W10MS_LOOP:	nop
		dec	akku0
		brne	w10ms_loop
; -------------
		pop	temp
		pop	akku0
		ret


; -----------------------------------------------------------------------------------------------
; Byte von EEPROM (Z) nach (temp) lesen:
; -----------------------------------------------------------------------------------------------

EEREAD:		sbic	EECR,EEPE		; sicherheitshalber auf
		rjmp	eeread			; ...Schreib-Ende warten...
		out	EEARH,ZH		; EEPROM-Adresse H speichern
		out	EEARL,ZL		; EEPROM-Adresse L speichern
		sbi	EECR,EERE		; EEPROM Leseoperation ausfhren
		in	temp,EEDR		; Datenbyte aus dem EEPROM lesen
; -------------
EEPARKEN:	push	temp
		clr	temp			; EEPROM-Adressregister
		out	EEARH,temp		; ...in Parkposition
		out	EEARL,temp		; ...stellen
		pop	temp
		ret



; -----------------------------------------------------------------------------------------------
; Byte in (temp) nach EEPROM (Z) schreiben:
; -----------------------------------------------------------------------------------------------

EEWRITE:	push	buffer			; Register retten
		mov	buffer,temp		; neues Byte retten
		wdr				; Watchdog beruhigen
		rcall	eeread			; EEPROM-Inhalt nach (temp) auslesen
		cp	temp,buffer		; Schreiboperation berhaupt ntig?
		breq	writenot		; nein...
;
; EEPROM muss verndert werden:
;
		pushsr				; Interruptstatus retten
		cli				; ***** Nicht unterbrechen!!!
		out	EEARH,ZH		; *	EEPROM-Adresse H speichern
		out	EEARL,ZL		; *	EEPROM-Adresse L speichern
		out	EEDR,buffer		; *	...und ins EEPROM schreiben
		sbi	EECR,EEMPE		; *	Master Write Enable setzen
		sbi	EECR,EEPE		; *	Write Strobe setzen
		popsr				; ***** wie zuvor
		rcall	eeparken		; Parkposition einstellen
WRITENOT:	pop	buffer			; Register restaurieren
		ret



; -----------------------------------------------------------------------------------------------
; Alle 10ms-Timer:
; -----------------------------------------------------------------------------------------------

TIMER10MS:	decram	t10ms			; 100ms abgelaufen?
		brne	timer10liste		; nein...
		ldi	temp,10			; Starte 100ms-
		sts	t10ms,temp		; ...Timer neu
; -------------
TIMER10LISTE:	
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; (counter)-Bytes von (Z+) nach (Y+) kopieren:
; -----------------------------------------------------------------------------------------------

MOVEZ2Y:	push	temp
; -------------
MZ2YLOOP:	ld	temp,Z+			; Byte aus RAM holen
		st	Y+,temp			; ...und umkopieren
		dec	counter			; alle kopiert?
		brne	mz2yloop		; nein...
; -------------
		pop	temp
		ret
